## e3 2.50

=== Makefile ===
# 1. edit you OS if you want....

OS=LINUX
#OS=BEOS
#OS=FREEBSD
#OS=OPENBSD
#OS=QNX
#OS=ATHEOS
#OS=W32 	** please use a separate make.bat for W9x **

# Set this to gzexe or upx if you want compression
# COMPRESS=gzexe

# 2. edit dest dir prefix if you want....

PREFIX='/usr/local'
#PREFIX=/boot/home


# 3. for vi friends only (else leave as is):
#    choice between '/bin/ex' or default '/bin/sed'
EXMODE=SED
#EXMODE=EX



BINDIR='$(PREFIX)/bin'
MANSEC='1'
MANDIR='$(PREFIX)/man/man$(MANSEC)'


#______________________do not edit below line________________________


ASOURCES=e3.asm e3.h
AFLAGS = -w+orphan-labels -f elf

# this fixes a nasty NASM version conflict
# NASM 0.98.08 claims to use -O2 by default, but does not.
# NASM 0.98    does not know the -O2 switch
#
ASVER := $(shell nasm -r)
ifeq	($(ASVER),NASM version 0.98)
	NASM=nasm
else
	NASM=nasm -O2
endif


all:	e3

e3:	$(ASOURCES) Makefile
ifeq	($(OS),LINUX)
	echo $(ASVER)
	$(NASM) -f bin -l e3.lst -o e3 e3.asm -DCRIPLED_ELF=1 -D$(OS) -D$(EXMODE)
	chmod +x e3
ifeq	($(COMPRESS),upx)
	if which upx > /dev/null 2>&1 ; then \
		upx -q -q -q -k -9 e3 ; \
	fi ;
endif
ifeq	($(COMPRESS),gzexe)
	if which gzexe > /dev/null 2>&1 ; then gzexe e3; fi;
endif
else
	echo $(ASVER)
	$(NASM) $(AFLAGS) -o e3.o e3.asm -l e3.lst -D$(OS) -D$(EXMODE)
ifeq	($(OS),QNX)
	ld -s -o e3 e3.o -lc
else
	ld -s -o e3 e3.o
endif
	strip --remove-section .comment e3
endif
	ln -sf e3 e3ws
	ln -sf e3 e3em
	ln -sf e3 e3pi
	ln -sf e3 e3vi
	ln -sf e3 e3ne

# next three are for testing purpose: linking w libc
statc:
	$(NASM) $(AFLAGS) -o e3.o e3.asm -l e3.lst -D$(OS) -DLIBC -D$(EXMODE)
	ld -s -static -o e3statc e3.o -lc

dync:
	$(NASM) $(AFLAGS) -o e3.o e3.asm -l e3.lst -D$(OS) -DLIBC -DDYN -D$(EXMODE)
	gcc e3.o -o e3dync
	# strip e3dync

dync2:
ifeq    ($(OS),LINUX)
	$(NASM) $(AFLAGS) -o e3.o e3.asm -l e3.lst -D$(OS) -DLIBC -DDYN -D$(EXMODE)
	ld -s -m elf_i386 -o e3dync2 e3.o   \
		-lc -dynamic-linker /lib/ld-linux.so.2 \
		/usr/lib/crt1.o /usr/lib/crti.o /usr/lib/crtn.o
else
	$(NASM) $(AFLAGS) -o e3.o e3.asm -l e3.lst -D$(OS) -DLIBC -DDYN -D$(EXMODE)
	ld -m elf_i386 -o e3dync2 e3.o -lc -e _start /usr/lib/crt1.o      
endif

# next for running in gnu debugger
debug:	$(ASOURCES) Makefile
	$(NASM) $(AFLAGS) -g -o e3.o e3.asm -l e3.lst -D$(OS) -D$(EXMODE)
	ld -s -o e3 e3.o
	strip --remove-section .comment e3
	ln -sf e3 e3ws
	ln -sf e3 e3em
	ln -sf e3 e3pi
	ln -sf e3 e3vi
	ln -sf e3 e3ne

# selftest, linux only, assembled with a special option for using an input pipe
test:
ifeq	($(OS),LINUX)
	$(NASM) -f bin -l e3.lst -o e3test e3.asm -DSELFTEST -DCRIPLED_ELF=1 -DLINUX -D$(EXMODE)
ifeq	($(COMPRESS),upx)
	if which upx > /dev/null 2>&1 ; then \
		upx -q -q -q -k -9 e3test ; \
	fi ;
endif
ifeq	($(COMPRESS),gzexe)
	if which gzexe > /dev/null 2>&1 ; then gzexe e3test; fi;
endif
	if [ -f PIPE_IN ]; then rm PIPE_IN ; fi
	if [ -f e3test~ ]; then rm e3test~ ; fi 
	chmod +x e3test
	cat e3.h tests/e3test0 | ./e3test
	clear
	diff e3.h PIPE_IN  && echo -e "\n\n\n**** THE TEST WAS SUCCESSFUL ****\n\n\n"
	rm PIPE_IN e3test
endif

# next for cross asm for the ELKS people
elks:
	nasm -w+orphan-labels -f as86 -o e3-16.o e3-16.asm -l e3-16.lst -D AS86 -D ELKS
	ld86 -0 -s -i -H 0xF800 -o e3-16 e3-16.o


# next two for cross asm testing
w32lst:
	$(NASM) -f coff -o e3.oW32 e3.asm -l e3.lstW32 -DW32
	rm e3.oW32

qnxlst:
	$(NASM) -f elf -o e3.oQNX e3.asm -l e3.lstQNX -DQNX
	rm e3.oQNX

# next for release maintainance
man2html:
	rman -f HTML e3.man >e3.html

install:	e3
ifeq	($(OS),QNX)
	cp ./e3 $(BINDIR)/e3
	ln -sf $(BINDIR)/e3 $(BINDIR)/e3ws
	ln -sf $(BINDIR)/e3 $(BINDIR)/e3em
	ln -sf $(BINDIR)/e3 $(BINDIR)/e3pi
	ln -sf $(BINDIR)/e3 $(BINDIR)/e3vi
	ln -sf $(BINDIR)/e3 $(BINDIR)/e3ne
else
	install -d $(PREFIX) $(BINDIR) $(MANDIR)
	install -m 755 e3 $(BINDIR)
	ln -sf $(BINDIR)/e3 $(BINDIR)/e3ws
	ln -sf $(BINDIR)/e3 $(BINDIR)/e3em
	ln -sf $(BINDIR)/e3 $(BINDIR)/e3pi
	ln -sf $(BINDIR)/e3 $(BINDIR)/e3vi
	ln -sf $(BINDIR)/e3 $(BINDIR)/e3ne
	install -m 644 e3.man $(MANDIR)/e3.$(MANSEC)
endif


armlinux:	e3
	@cd armlinux && make all


clean:
	rm -f e3*.o e3*.lst e3 e3em e3pi e3vi e3ws e3ne *~ \
		PIPE_IN e3test~ e3test e3dync e3dync2 e3statc \
		armlinux/*.o armlinux/e3arm

## e3 2.61

=== Makefile ===
--- 
+++ 
@@ -110,6 +110,34 @@
 	ln -sf e3 e3vi
 	ln -sf e3 e3ne
 
+# L I N U X   only
+# Experimental stuff for using YASM assembler
+# needs some sed changes (jmp vs jmp near) due heavy bugs in YASM optimizer
+# (how to switch off that optimizer ?)
+yasm:	$(ASOURCES) Makefile
+	cat e3.asm | sed -f e3_nasm_yasm.sed \
+		| yasm -f elf -p nasm $(AFLAGS) -l e3.lstyasm -o e3.o -DLINUX -DSED -DYASM
+	ld -s -o e3 e3.o
+	ln -sf e3 e3ws
+	ln -sf e3 e3em
+	ln -sf e3 e3pi
+	ln -sf e3 e3vi
+	ln -sf e3 e3ne
+
+# L I N U X / AMD-64  only
+# ditto YASM stuff
+yasm64:	$(ASOURCES) Makefile
+	cat e3.asm 	| sed -f e3_nasm_yasm.sed \
+			| sed -f e3_yasm_yasm64.sed \
+		| yasm  -m amd64 -f elf -p nasm $(AFLAGS) -l e3.lstyasm64 -o e3.o -DLINUX -DSED -DYASM -DAMD64
+	ld -s -o e3 e3.o
+	ln -sf e3 e3ws
+	ln -sf e3 e3em
+	ln -sf e3 e3pi
+	ln -sf e3 e3vi
+	ln -sf e3 e3ne
+
+
 # selftest, linux only, assembled with a special option for using an input pipe
 test:
 ifeq	($(OS),LINUX)

=== bin/NetBSD/Makefile ===
# Makefile for NetBSD 
# (does not use GNU make extensions)
#
# On NetBSD we use some kind of Linux emulation mode
#  (so you can use Linux settings completely)
# See some output from ktrace:
#   382 ktrace   EMUL  "netbsd"
#   382 ktrace   RET   ktrace 0
#   382 ktrace   CALL  execve(0xbfbfdd77,0xbfbfdd00,0xbfbfdd0c)
#   382 ktrace   NAMI  "./e3"
#   382 e3       EMUL  "linux"
#   .........
#


# 1. edit you OS if you want....

OS=LINUX	# okay for NetBSD
#OS=BEOS
#OS=FREEBSD
#OS=OPENBSD
#OS=QNX
#OS=W32 	** please use a separate make.bat for W9x **

# 2. edit dest dir prefix if you want....

PREFIX='/usr/local'


# 3. for vi friends only (else leave as is):
#    choice between '/bin/ex' or default '/bin/sed'
EXMODE=SED
#EXMODE=EX



BINDIR='$(PREFIX)/bin'
MANSEC='1'
MANDIR='$(PREFIX)/man/man$(MANSEC)'


#______________________do not edit below line________________________


ASOURCES=e3.asm
AFLAGS = -w+orphan-labels -f elf


all:	$(ASOURCES) Makefile
	nasm $(AFLAGS) -o e3.o $(ASOURCES) -l e3.lst -D$(OS) -D$(EXMODE)
	ld -s -o e3 e3.o
	strip --remove-section .comment e3
	ln -sf e3 e3ws
	ln -sf e3 e3em
	ln -sf e3 e3pi
	ln -sf e3 e3vi
	ln -sf e3 e3ne

install:	e3
	install -d $(PREFIX) $(BINDIR) $(MANDIR)
	install -m 755 e3 $(BINDIR)
	ln -sf $(BINDIR)/e3 $(BINDIR)/e3ws
	ln -sf $(BINDIR)/e3 $(BINDIR)/e3em
	ln -sf $(BINDIR)/e3 $(BINDIR)/e3pi
	ln -sf $(BINDIR)/e3 $(BINDIR)/e3vi
	ln -sf $(BINDIR)/e3 $(BINDIR)/e3ne
	install -m 644 e3.man $(MANDIR)/e3.$(MANSEC)

clean:
	rm -f e3*.o e3*.lst e3 e3em e3pi e3vi e3ws e3ne

## e3 2.71

=== Makefile ===
# 1. edit you OS if you want....

OS=LINUX
#OS=BEOS
#OS=FREEBSD
#OS=OPENBSD
#OS=QNX
#OS=ATHEOS
#OS=W32 	** please use a separate make.bat for W9x **
#OS=NETBSD

# Set this to gzexe or upx if you want compression
# COMPRESS=gzexe

# 2. edit dest dir prefix if you want....

PREFIX='/usr/local'
#PREFIX=/boot/home


# 3. for vi friends only (else leave as is):
#    choice between '/bin/ex' or default '/bin/sed'
EXMODE=SED
#EXMODE=EX



BINDIR='$(PREFIX)/bin'
MANSEC='1'
MANDIR='$(PREFIX)/man/man$(MANSEC)'


#______________________do not edit below line________________________


ASOURCES=e3.asm e3.h
AFLAGS = -w+orphan-labels -f elf
NASM=nasm -O2


all:	e3

e3:	$(ASOURCES) Makefile
ifeq	($(OS),LINUX)
	$(NASM) -f bin -l e3.lst -o e3 e3.asm -DCRIPLED_ELF=1 -D$(OS) -D$(EXMODE) -DNASM
	chmod +x e3
ifeq	($(COMPRESS),upx)
	if which upx > /dev/null 2>&1 ; then \
		upx -q -q -q -k -9 e3 ; \
	fi ;
endif
ifeq	($(COMPRESS),gzexe)
	if which gzexe > /dev/null 2>&1 ; then gzexe e3; fi;
endif
else
	echo $(ASVER)
	$(NASM) $(AFLAGS) -o e3.o e3.asm -l e3.lst -D$(OS) -D$(EXMODE) -DNASM
ifeq	($(OS),QNX)
	ld -s -o e3 e3.o -lc
else
	ld -s -o e3 e3.o
endif
	strip --remove-section .comment e3
endif
	ln -sf e3 e3ws
	ln -sf e3 e3em
	ln -sf e3 e3pi
	ln -sf e3 e3vi
	ln -sf e3 e3ne


# next for running in gnu debugger
debug:	$(ASOURCES) Makefile
	$(NASM) $(AFLAGS) -g -o e3.o e3.asm -l e3.lst -D$(OS) -D$(EXMODE) -DNASM
	ld  -b elf32-i386  --oformat elf32-i386 -s -o e3 e3.o
	strip --remove-section .comment e3
	ln -sf e3 e3ws
	ln -sf e3 e3em
	ln -sf e3 e3pi
	ln -sf e3 e3vi
	ln -sf e3 e3ne

# L I N U X   only
# Experimental stuff for using YASM assembler
# needs some sed changes (jmp vs jmp near) due heavy bugs in YASM optimizer
# (how to switch off that optimizer ?)
yasm:	$(ASOURCES) Makefile
	cat e3.asm | sed -f e3_nasm_yasm.sed > e3.tmp
	yasm -a x86 -m x86 -f elf32 -p nasm $(AFLAGS) -l e3.lstyasm -o e3.o -DLINUX -DSED -DYASM e3.tmp
	rm e3.tmp
	ld -b elf32-i386  --oformat elf32-i386 -s -o e3 e3.o
	ln -sf e3 e3ws
	ln -sf e3 e3em
	ln -sf e3 e3pi
	ln -sf e3 e3vi
	ln -sf e3 e3ne

# L I N U X / AMD-64  only
# ditto YASM stuff
yasm64:	$(ASOURCES) Makefile
	cat e3.asm 	| sed -f e3_nasm_yasm.sed \
			| sed -f e3_yasm_yasm64.sed >e3.tmp
	yasm  -a x86 -m amd64 -f elf64 -p nasm -L nasm $(AFLAGS) \
			-l e3.lstyasm64 -o e3.o -DLINUX -DSED -DYASM -DAMD64 e3.tmp
	rm e3.tmp
	ld -b elf64-x86-64 --oformat elf64-x86-64 -s -o e3 e3.o
	ln -sf e3 e3ws
	ln -sf e3 e3em
	ln -sf e3 e3pi
	ln -sf e3 e3vi
	ln -sf e3 e3ne

# L I N U X   only
# Experimental stuff for using NASM assembler
nasm64:	$(ASOURCES) Makefile
	cat e3.asm 	| sed -f e3_nasm_yasm.sed \
			| sed -f e3_yasm_yasm64.sed >e3.tmp
	$(NASM) -w+orphan-labels -f elf64  -o e3.o e3.tmp -l e3.lst64 -DLINUX -DSED -DYASM -DAMD64 -DNASM
	rm e3.tmp
	ld -b elf64-x86-64 --oformat elf64-x86-64 -s -o e3 e3.o
	ln -sf e3 e3ws
	ln -sf e3 e3em
	ln -sf e3 e3pi
	ln -sf e3 e3vi
	ln -sf e3 e3ne

# added for compatibility reason:
nasm32:	e3

# next for cross asm for the ELKS people
elks:
	nasm -w+orphan-labels -f as86 -o e3-16.o e3-16.asm -l e3-16.lst -D AS86 -D ELKS -DNASM
	ld86 -0 -s -i -H 0xF800 -o e3-16 e3-16.o


# next two for cross asm testing
w32lst:
	$(NASM) -f coff -o e3.oW32 e3.asm -l e3.lstW32 -DW32 -DNASM
	rm e3.oW32

qnxlst:
	$(NASM) -f elf -o e3.oQNX e3.asm -l e3.lstQNX -DQNX -DNASM
	rm e3.oQNX

# next for release maintainance
man2html:
	rman -f HTML e3.man >e3.html

install:	e3
ifeq	($(OS),QNX)
	cp ./e3 $(BINDIR)/e3
	ln -sf $(BINDIR)/e3 $(BINDIR)/e3ws
	ln -sf $(BINDIR)/e3 $(BINDIR)/e3em
	ln -sf $(BINDIR)/e3 $(BINDIR)/e3pi
	ln -sf $(BINDIR)/e3 $(BINDIR)/e3vi
	ln -sf $(BINDIR)/e3 $(BINDIR)/e3ne
else
	install -d $(PREFIX) $(BINDIR) $(MANDIR)
	install -m 755 e3 $(BINDIR)
	ln -sf $(BINDIR)/e3 $(BINDIR)/e3ws
	ln -sf $(BINDIR)/e3 $(BINDIR)/e3em
	ln -sf $(BINDIR)/e3 $(BINDIR)/e3pi
	ln -sf $(BINDIR)/e3 $(BINDIR)/e3vi
	ln -sf $(BINDIR)/e3 $(BINDIR)/e3ne
	install -m 644 e3.man $(MANDIR)/e3.$(MANSEC)
endif


armlinux:	e3
	@cd armlinux && make all


clean:
	rm -f e3*.o e3*.lst e3 e3em e3pi e3vi e3ws e3ne *~ \
		PIPE_IN e3test~ e3test e3dync e3dync2 e3statc \
		armlinux/*.o armlinux/e3arm

=== armlinux/Makefile ===
AS=arm-linux-as
LD=arm-linux-ld
STRIP=arm-linux-strip

all:	../e3.asm e3.s
#	$(AS) --defsym LINUX=1 --defsym ARMCPU=1 -a=e3arm.lst -gstabs e3.s -o e3.o
#	$(AS) --defsym LINUX=1 --defsym ARMCPU=1 -a=emulayer.lst -gstabs emulayer.s -o emulayer.o
	$(AS) --defsym LINUX=1 --defsym ARMCPU=1 e3.s -o e3.o
	$(AS) --defsym LINUX=1 --defsym ARMCPU=1 emulayer.s -o emulayer.o
	$(LD) e3.o emulayer.o -o e3arm 
	$(STRIP) e3arm

=== elks/Makefile ===
ASOURCES=e3-16.asm
AFLAGS	= -w+orphan-labels -f as86

all:	$(ASOURCES) Makefile
	nasm $(AFLAGS) -o e3-16.o $(ASOURCES) -l e3-16.lst -D AS86 -D ELKS
	ld86 -0 -s -i -H 0xF800 -o e3-16 e3-16.o


clean:
	rm -f e3*.o e3*.lst e3-16

=== bin/OpenBSD/Makefile ===
# Makefile for OpenBSD 
# (does not use GNU make extensions)
#

# 1. edit you OS if you want....

#OS=LINUX
#OS=BEOS
#OS=FREEBSD
OS=OPENBSD
#OS=QNX
#OS=W32 	** please use a separate make.bat for W9x **

# 2. edit dest dir prefix if you want....

PREFIX='/usr/local'


# 3. for vi friends only (else leave as is):
#    choice between '/bin/ex' or default '/bin/sed'
EXMODE=SED
#EXMODE=EX



BINDIR='$(PREFIX)/bin'
MANSEC='1'
MANDIR='$(PREFIX)/man/man$(MANSEC)'


#______________________do not edit below line________________________


ASOURCES=e3.asm
AFLAGS = -w+orphan-labels -f elf


all:	$(ASOURCES) Makefile
	nasm $(AFLAGS) -o e3.o $(ASOURCES) -l e3.lst -D$(OS) -D$(EXMODE)
	ld -s -o e3 e3.o
	strip --remove-section .comment e3
	ln -sf e3 e3ws
	ln -sf e3 e3em
	ln -sf e3 e3pi
	ln -sf e3 e3vi
	ln -sf e3 e3ne

install:	e3
	install -d $(PREFIX) $(BINDIR) $(MANDIR)
	install -m 755 e3 $(BINDIR)
	ln -sf $(BINDIR)/e3 $(BINDIR)/e3ws
	ln -sf $(BINDIR)/e3 $(BINDIR)/e3em
	ln -sf $(BINDIR)/e3 $(BINDIR)/e3pi
	ln -sf $(BINDIR)/e3 $(BINDIR)/e3vi
	ln -sf $(BINDIR)/e3 $(BINDIR)/e3ne
	install -m 644 e3.man $(MANDIR)/e3.$(MANSEC)

clean:
	rm -f e3*.o e3*.lst e3 e3em e3pi e3vi e3ws e3ne

=== debian/changelog ===
e3 (1:2.71-2) unstable; urgency=medium

  * QA upload.
  * Set Maintainer field to QA group
  * wrap-and-sort -sta
  * Fix whitespace errors in following files:
    + debian/changelog
    + debian/postinst
  * Update standards version to 4.3.0 (no changes needed)
  * Update debhelper compat to 11
  * Build-depend on `debhelper-compat' (obsoletes `debian/compat')
  * Update Vcs-* fields in `debian/control'
  * Convert source format to 3.0 (quilt), unapplied
  * Simplify `debian/rules'
  * Apply patch to avoid segmentation faults (Closes: #913014)
    + Thanks: Bernhard Übelacker <bernhardu@mailbox.org>
  * Improve wording and formatting of package description
  * Update lintian-overrides file

 -- Dmitry Bogatov <KAction@debian.org>  Sun, 13 Jan 2019 17:46:12 +0000

e3 (1:2.71-1) unstable; urgency=low

  * New upstream version
  * General cleanup (lintian warnings, standards version, etc.)

 -- Paweł Więcek <coven@debian.org>  Sat, 08 Mar 2008 14:31:17 +0100

e3 (1:2.70-3) unstable; urgency=high

  * Workaround upx problem appearing on *some* autobuilders by dropping upx
    (closes: #383164)
  * Urgency=high because it's release critical

 -- Paweł Więcek <coven@debian.org>  Thu, 28 Dec 2006 22:15:13 +0100

e3 (1:2.70-2) unstable; urgency=low

  * Added support for calling as 'ws', 'emacs', 'pico', 'vi' or 'nedit'
    (closes: #345173)
  * Added kfreebsd-amd64 to arch list (closes: #361628)

 -- Paweł Więcek <coven@debian.org>  Fri, 21 Apr 2006 23:14:02 +0200

e3 (1:2.70-1) unstable; urgency=low

  * New upstream version
  * Updated to current debhelper

 -- Pawel Wiecek <coven@debian.org>  Wed, 29 Mar 2006 23:32:05 +0200

e3 (1:2.61-2) unstable; urgency=low

  * Added kfreebsd-i386 to arch list (closes: #314337)
  * Updated standards-version (no changes required)
  * Updated debian/menu to current preferred format
  * Fixed prerm (closes: #328284, #301784)

 -- Pawel Wiecek <coven@debian.org>  Thu, 22 Sep 2005 21:33:34 +0200

e3 (1:2.61-1) unstable; urgency=low

  * New upstream version

 -- Pawel Wiecek <coven@debian.org>  Sat,  8 Jan 2005 17:52:59 +0100

e3 (1:2.50-1) unstable; urgency=low

  * New upstream version
  * Added amd64 support (closes: #249972)
  * Updated standards version (no changes required)

 -- Pawel Wiecek <coven@debian.org>  Wed,  9 Jun 2004 00:12:26 +0200

e3 (1:2.43-1) unstable; urgency=low

  * New upstream version

 -- Pawel Wiecek <coven@debian.org>  Wed, 23 Apr 2003 15:11:24 +0200

e3 (1:2.40-1) unstable; urgency=low

  * New upstream version

 -- Pawel Wiecek <coven@debian.org>  Mon, 14 Oct 2002 12:14:03 +0200

e3 (1:2.33-1) unstable; urgency=low

  * New upstream version

 -- Pawel Wiecek <coven@debian.org>  Fri, 24 May 2002 13:40:06 +0200

e3 (1:2.31-1) unstable; urgency=low

  * New upstream version
  * Fixed mistaken version numbering (closes: #144003)

 -- Pawel Wiecek <coven@debian.org>  Tue, 23 Apr 2002 11:28:47 +0200

e3 (e3-2.30-1) unstable; urgency=low

  * New upstream version

 -- Pawel Wiecek <coven@debian.org>  Mon,  8 Apr 2002 20:38:38 +0200

e3 (2.21-1) unstable; urgency=low

  * New upstream version

 -- Pawel Wiecek <coven@debian.org>  Mon, 18 Mar 2002 21:26:14 +0100

e3 (2.20-1) unstable; urgency=low

  * New upstream version
  * Renumbered from upstream version number 2.2 to 2.20

 -- Pawel Wiecek <coven@debian.org>  Tue, 12 Mar 2002 15:07:06 +0100

e3 (2.11-1) unstable; urgency=low

  * New upstream version
  * Fixed prerm to remove the *correct* links (closes: #135496)

 -- Pawel Wiecek <coven@debian.org>  Tue,  5 Mar 2002 13:59:26 +0100

e3 (2.1-1) unstable; urgency=low

  * New upstream version (closes: #133879)
  * Two short jumps converted to long ones -- new nasm generates some
    additional bytes of code (!!!)

 -- Pawel Wiecek <coven@debian.org>  Thu, 14 Feb 2002 12:58:36 +0100

e3 (2.0-3) unstable; urgency=low

  * New maintainer (closes: #130820)
  * Refreshed package a bit -- new debhelper, updated standards-version
  * I had to convert one short jump to a long one -- otherwise nasm produced
    error. I'd have to examine it further...

 -- Pawel Wiecek <coven@debian.org>  Fri,  1 Feb 2002 14:11:04 +0100

e3 (2.0-2) unstable; urgency=low

  * Orphaned this package.

 -- Adrian Bunk <bunk@fs.tum.de>  Fri, 25 Jan 2002 12:46:05 +0100

e3 (2.0-1) unstable; urgency=high

  * New upstream release.

 -- Adrian Bunk <bunk@fs.tum.de>  Thu,  3 Jan 2002 12:14:41 +0100

e3 (1.9-1) unstable; urgency=high

  * New upstream release.
    - It's now possible to suspend e3 using ^Z. (closes: #119363)

 -- Adrian Bunk <bunk@fs.tum.de>  Fri,  7 Dec 2001 09:12:10 +0100

e3 (1.8.2-1) unstable; urgency=high

  * New upstream release.

 -- Adrian Bunk <bunk@fs.tum.de>  Fri, 30 Nov 2001 17:07:57 +0100

e3 (1.8.1-1) unstable; urgency=low

  * New upstream release.
  * Lower the priorities at the update-alternatives calls from
    20 to 10 in debian/postinst.

 -- Adrian Bunk <bunk@fs.tum.de>  Sat, 17 Nov 2001 18:09:23 +0100

e3 (1.7-1) unstable; urgency=low

  * New upstream release.

 -- Adrian Bunk <bunk@fs.tum.de>  Wed, 11 Jul 2001 11:30:47 +0200

e3 (1.6.2-1) unstable; urgency=low

  * New upstream release.

 -- Adrian Bunk <bunk@fs.tum.de>  Sun,  1 Jul 2001 18:46:16 +0200

e3 (1.5-1) unstable; urgency=low

  * New upstream release.
  * Added a patch sent by Chad C. Walstrom <chewie@wookimus.net>
    to add some alternatives. (closes: #90152)
  * Standards-Version: 3.5.4 (no changes)

 -- Adrian Bunk <bunk@fs.tum.de>  Sat,  5 May 2001 21:03:19 +0200

e3 (1.4-3) unstable; urgency=low

  * Use upx instead of gzexe. (closes: #92340)

 -- Adrian Bunk <bunk@fs.tum.de>  Fri, 13 Apr 2001 01:14:46 +0200

e3 (1.4-2) unstable; urgency=low

  * Use gzexe to make e3 smaller. (closes: #75807)
  * Standards-Version: 3.5.2 (no changes)

 -- Adrian Bunk <bunk@fs.tum.de>  Fri, 16 Mar 2001 00:52:04 +0100

e3 (1.4-1) unstable; urgency=low

  * New upstream release.
  * Corrected the symlinks for e3?? . (closes: #79787)



=== debian/control ===
Source: e3
Section: editors
Priority: optional
Maintainer: Debian QA Group <packages@qa.debian.org>
Build-Depends:
 debhelper-compat (= 11),
 nasm,
Standards-Version: 4.3.0
Vcs-Git: https://salsa.debian.org/debian/e3.git
Vcs-Browser: https://salsa.debian.org/debian/e3
Homepage: http://mitglied.lycos.de/albkleine/

Package: e3
Architecture: amd64 i386 kfreebsd-amd64 kfreebsd-i386
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: very small text editor
 This package contains an editor you can call via the following links:
 .
  * e3em: Emacs-like key bindings
  * e3vi: Vi-like key bindings
  * e3pi: Pico-like key bindings
  * e3ne: Nedit-like key bindings
  * e3ws: Wordstar-like key bindings
 .
 e3 has the following advantages over other editors:
   - it has no library dependencies
   - one very small binary (only 10 kB) that gives you 5 editors

=== debian/watch ===
version=3

opts=dversionmangle=s/(\d)$/.$1/ \
  http://mitglied.lycos.de/albkleine/ e3-(.+)\.tar\.gz

## e3 2.82%2Bdfsg

=== debian/watch ===
version=4
opts=dversionmangle=s/\+dfsg$// \
  https://sites.google.com/site/e3editor/system/app/pages/recentChanges \
  https://sites.google.com/site/e3editor/Home/e3-(.*)\.tgz(?:.*)

## e3 2.82+dfsg

=== Makefile ===
# 1. edit you OS if you want....

OS=LINUX
#OS=FREEBSD
#OS=OPENBSD
#OS=NETBSD

# 2. edit dest dir prefix if you want....

PREFIX='/usr/local'

# 3. for programmers only: debugging in 64 bit Linux
DEBUG=false
#DEBUG=true

# 4. decide for nasm or yasm assembler (for 64 bit Linux version only)
NASM_OR_YASM=nasm
#NASM_OR_YASM=yasm

EXMODE=SED

#----------------------do not edit below line-------------------------------

BINDIR='$(PREFIX)/bin'
MANSEC='1'
MANDIR='$(PREFIX)/man/man$(MANSEC)'

ASOURCES=e3.asm e3.h
AFLAGS = -w+orphan-labels -f elf

ifeq	($(NASM_OR_YASM),nasm)
 ASSEMBLER64=nasm -O2 -g -w+orphan-labels -f elf64  -o e3.o e3.tmp -l e3nasm64.lst -DLINUX -DSED  -DAMD64
else
 ASSEMBLER64=yasm -g STABS -a x86 -m amd64 -f elf64 -p nasm -L nasm $(AFLAGS) -l e3yasm64.lst -o e3.o -DLINUX -DSED -DYASM -DAMD64 e3.tmp
endif

#---------------- default--------------------------
all:	32

#---------------- 32 bit LINUX (and perhaps BSD) --

32:	$(ASOURCES) Makefile
ifeq	($(OS),LINUX)
	nasm -O2 -f bin -l e3.lst -o e3 e3.asm -DCRIPLED_ELF=1 -D$(OS) -D$(EXMODE) 
	chmod +x e3
else
	echo $(ASVER)
	nasm -O2 $(AFLAGS) -o e3.o e3.asm -l e3.lst -D$(OS) -D$(EXMODE)
	ld -s -o e3 e3.o
	strip --remove-section .comment e3
endif
	ln -sf e3 e3ws
	ln -sf e3 e3em
	ln -sf e3 e3pi
	ln -sf e3 e3vi
	ln -sf e3 e3ne

# ------------- 64 bit L I N U X ------------------

64:	$(ASOURCES) Makefile
	cat e3.asm | sed -f e3_32to64.sed  >e3.tmp
	$(ASSEMBLER64)
	ld -b elf64-x86-64 --oformat elf64-x86-64 -o e3 e3.o
ifneq	($(DEBUG),true)
	strip e3
endif
	ln -sf e3 e3ws
	ln -sf e3 e3em
	ln -sf e3 e3pi
	ln -sf e3 e3vi
	ln -sf e3 e3ne

# -------------------------------------------------

install:	e3
	install -d $(PREFIX) $(BINDIR) $(MANDIR)
	install -m 755 e3 $(BINDIR)
	ln -sf $(BINDIR)/e3 $(BINDIR)/e3ws
	ln -sf $(BINDIR)/e3 $(BINDIR)/e3em
	ln -sf $(BINDIR)/e3 $(BINDIR)/e3pi
	ln -sf $(BINDIR)/e3 $(BINDIR)/e3vi
	ln -sf $(BINDIR)/e3 $(BINDIR)/e3ne
	install -m 644 e3.man $(MANDIR)/e3.$(MANSEC)

clean:
	rm -f e3*.o e3*.lst e3.tmp e3 e3em e3pi e3vi e3ws e3ne *~

=== debian/changelog ===
e3 (1:2.82+dfsg-2) unstable; urgency=medium

  * QA upload.
  * Upload to unstable.

 -- Adrian Bunk <bunk@debian.org>  Wed, 10 Feb 2021 14:58:27 +0200

e3 (1:2.82+dfsg-1) experimental; urgency=medium

  * QA upload.
  * Exclude pre-built binaries from upstream tarball.
  * Update "debian/watch" to use new project home.
  * Update homepage information in "debian/control".
  * New upstream release.
  * Install symlinks in /usr/share/man to match symlinks in /bin.

 -- Dmitry Bogatov <KAction@debian.org>  Sun, 12 May 2019 05:23:30 +0000

=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
 Standards-Version: 4.3.0
 Vcs-Git: https://salsa.debian.org/debian/e3.git
 Vcs-Browser: https://salsa.debian.org/debian/e3
-Homepage: http://mitglied.lycos.de/albkleine/
+Homepage: https://sites.google.com/site/e3editor/
 
 Package: e3
 Architecture: amd64 i386 kfreebsd-amd64 kfreebsd-i386

=== debian/watch ===
version=3

opts=dversionmangle=s/\+dfsg$// \
  https://sites.google.com/site/e3editor/system/app/pages/recentChanges \
  https://sites.google.com/site/e3editor/Home/e3-(.*)\.tgz(?:.*)

## e3 e3

=== Makefile ===
# 1. edit you OS if you want....

OS=LINUX
#OS=BEOS
#OS=FREEBSD
#OS=QNX
#OS=ATHEOS
#OS=W32 	** please use a separate make.bat for W9x **

# Set this to gzexe or upx if you want compression
COMPRESS=gzexe

# 2. edit dest dir prefix if you want....

PREFIX='/usr/local'
#PREFIX=/boot/home


# 3. for vi friends only (else leave as is):
#    choice between '/bin/ex' or default '/bin/sed'
EXMODE=SED
#EXMODE=EX



BINDIR='$(PREFIX)/bin'
MANSEC='1'
MANDIR='$(PREFIX)/man/man$(MANSEC)'


#______________________do not edit below line________________________


ASOURCES=e3.asm e3.h
AFLAGS = -w+orphan-labels -f elf

# this fixes a nasty NASM version conflict
# NASM 0.98.08 claims to use -O2 by default, but does not.
# NASM 0.98    does not know the -O2 switch
#
ASVER := $(shell nasm -r)
ifeq	($(ASVER),NASM version 0.98)
	NASM=nasm
else
	NASM=nasm -O2
endif


all:	e3

e3:	$(ASOURCES) Makefile
ifeq	($(OS),LINUX)
	echo $(ASVER)
	$(NASM) -f bin -l e3.lst -o e3 e3.asm -DCRIPLED_ELF=1 -D$(OS) -D$(EXMODE)
	chmod +x e3
ifeq	($(COMPRESS),upx)
	if which upx > /dev/null 2>&1 ; then \
		upx -q -q -q -k -9 e3 ; \
	fi ;
endif
ifeq	($(COMPRESS),gzexe)
	if which gzexe > /dev/null 2>&1 ; then gzexe e3; fi;
endif
else
	echo $(ASVER)
	$(NASM) $(AFLAGS) -o e3.o e3.asm -l e3.lst -D$(OS) -D$(EXMODE)
ifeq	($(OS),QNX)
	ld -s -o e3 e3.o -lc
else
	ld -s -o e3 e3.o
endif
	strip --remove-section .comment e3
endif
	ln -sf e3 e3ws
	ln -sf e3 e3em
	ln -sf e3 e3pi
	ln -sf e3 e3vi
	ln -sf e3 e3ne

# next three are for testing purpose: linking w libc
statc:
	$(NASM) $(AFLAGS) -o e3.o e3.asm -l e3.lst -DLINUX -DLIBC -D$(EXMODE)
	ld -s -static -o e3statc e3.o -lc

dync:
	$(NASM) $(AFLAGS) -o e3.o e3.asm -l e3.lst -DLINUX -DLIBC -DDYN -D$(EXMODE)
	gcc e3.o -o e3dync
	# strip e3dync

dync2:
	$(NASM) $(AFLAGS) -o e3.o e3.asm -l e3.lst -DLINUX -DLIBC -DDYN -D$(EXMODE)
	ld -s -m elf_i386 -o e3dync2 e3.o   \
		-lc -dynamic-linker /lib/ld-linux.so.2 \
		/usr/lib/crt1.o /usr/lib/crti.o /usr/lib/crtn.o
      

# next for running in gnu debugger
debug:	$(ASOURCES) Makefile
	$(NASM) $(AFLAGS) -g -o e3.o e3.asm -l e3.lst -D$(OS) -D$(EXMODE)
	ld -s -o e3 e3.o
	strip --remove-section .comment e3
	ln -sf e3 e3ws
	ln -sf e3 e3em
	ln -sf e3 e3pi
	ln -sf e3 e3vi
	ln -sf e3 e3ne

# selftest, linux only, assembled with a special option for using an input pipe
test:
ifeq	($(OS),LINUX)
	$(NASM) -f bin -l e3.lst -o e3test e3.asm -DSELFTEST -DCRIPLED_ELF=1 -DLINUX -D$(EXMODE)
ifeq	($(COMPRESS),upx)
	if which upx > /dev/null 2>&1 ; then \
		upx -q -q -q -k -9 e3test ; \
	fi ;
endif
ifeq	($(COMPRESS),gzexe)
	if which gzexe > /dev/null 2>&1 ; then gzexe e3test; fi;
endif
	if [ -f PIPE_IN ]; then rm PIPE_IN ; fi
	if [ -f e3test~ ]; then rm e3test~ ; fi 
	chmod +x e3test
	cat e3.h tests/e3test0 | ./e3test
	clear
	diff e3.h PIPE_IN  && echo -e "\n\n\n**** THE TEST WAS SUCCESSFUL ****\n\n\n"
	rm PIPE_IN e3test
endif

# next for cross asm for the ELKS people
elks:
	nasm -w+orphan-labels -f as86 -o e3-16.o e3-16.asm -l e3-16.lst -D AS86 -D ELKS
	ld86 -0 -s -i -H 0xF800 -o e3-16 e3-16.o


# next two for cross asm testing
w32lst:
	$(NASM) -f coff -o e3.oW32 e3.asm -l e3.lstW32 -DW32
	rm e3.oW32

qnxlst:
	$(NASM) -f elf -o e3.oQNX e3.asm -l e3.lstQNX -DQNX
	rm e3.oQNX

# next for release maintainance
man2html:
	rman -f HTML e3.man >e3.html

install:	e3
ifeq	($(OS),QNX)
	cp ./e3 $(BINDIR)/e3
	ln -sf $(BINDIR)/e3 $(BINDIR)/e3ws
	ln -sf $(BINDIR)/e3 $(BINDIR)/e3em
	ln -sf $(BINDIR)/e3 $(BINDIR)/e3pi
	ln -sf $(BINDIR)/e3 $(BINDIR)/e3vi
	ln -sf $(BINDIR)/e3 $(BINDIR)/e3ne
else
	install -d $(PREFIX) $(BINDIR) $(MANDIR)
	install -m 755 e3 $(BINDIR)
	ln -sf $(BINDIR)/e3 $(BINDIR)/e3ws
	ln -sf $(BINDIR)/e3 $(BINDIR)/e3em
	ln -sf $(BINDIR)/e3 $(BINDIR)/e3pi
	ln -sf $(BINDIR)/e3 $(BINDIR)/e3vi
	ln -sf $(BINDIR)/e3 $(BINDIR)/e3ne
	install -m 644 e3.man $(MANDIR)/e3.$(MANSEC)
endif

clean:
	rm -f e3*.o e3*.lst e3 e3em e3pi e3vi e3ws e3ne *~ \
		PIPE_IN e3test~ e3test e3dync e3dync2 e3statc

=== e3c/Makefile ===
# edit dest dir prefix if you want....

        PREFIX='/usr/local'
#	PREFIX=/boot/home
#	(used /boot/home in BeOS)

LIBDIR='$(PREFIX)/lib'
BINDIR='$(PREFIX)/bin'
MANSEC='1'
MANDIR='$(PREFIX)/man/man$(MANSEC)'


##_____________________________________________________________

CTARGET=e3c
CSOURCES=e3.c
CFLAGS = -Wall  -g -O2 -fomit-frame-pointer

all: $(CTARGET)


$(CTARGET): $(CSOURCES) Makefile
	gcc $(CFLAGS) -DLIBDIR=\"$(PREFIX)/lib\" $(CSOURCES) -o $(CTARGET)
	strip $(CTARGET)

list:	$(CSOURCES) Makefile
	gcc $(CFLAGS) -Wa,-a -c -g -DLIBDIR=\"$(PREFIX)/lib\" $(CSOURCES) >e3c.list

install: $(CTARGET)
	install -d $(PREFIX) $(BINDIR) $(LIBDIR) $(MANDIR)
	install -m 755 $(CTARGET) $(BINDIR)
	install -m 644 e3ws.hlp $(LIBDIR)
	install -m 644 e3.res $(LIBDIR)	
	install -m 644 $(CTARGET).man $(MANDIR)/$(CTARGET).$(MANSEC)

=== bin/NetBSD/Makefile ===
--- 
+++ 
@@ -18,7 +18,6 @@
 OS=LINUX	# okay for NetBSD
 #OS=BEOS
 #OS=FREEBSD
-#OS=OPENBSD
 #OS=QNX
 #OS=W32 	** please use a separate make.bat for W9x **

=== bin/OpenBSD/Makefile ===
--- 
+++ 
@@ -6,8 +6,7 @@
 
 #OS=LINUX
 #OS=BEOS
-#OS=FREEBSD
-OS=OPENBSD
+OS=FREEBSD	# okay for OpenBSD
 #OS=QNX
 #OS=W32 	** please use a separate make.bat for W9x **
